import java.lang.*;

/*
-------------------------------------------------------------------------------
Efecte d'una inversio termica en alc,ada
-------------------------------------------------------------------------------
Dades: hi (alc,ada a la que comenc,a la inversio), hx (alc,ada de la xemeneia),
       v (velocitat del vent), npart (nombre de particules que es simulen),
       dt (duracio de cada pas de temps), max (nombre de passos de temps que
       es calculen)
Resultats: Al fitxer "aire1.dat". Cada fila representa un instant de temps.
           A la primera columna hi ha l'ordinal de la fila. A la segona
           l'alc,ada d'una particula en cert instant de temps.
Dades de prova: hi=100 hx=80 v=1 dt=1 npart=20 max=200 ==>
1.0 79.799999999999997
2.0 80.200000000000003
3.0 78.799999999999997
4.0 79.0
5.0 78.200000000000003
6.0 78.200000000000003
7.0 78.0
... ...
Observacions: Els resultats s'han de representar sense que cap linia uneixi els
              punts, per poder veure'ls millor.
-------------------------------------------------------------------------------
*/

public class Aire1Calculs {
	double dt,hi,hx,v,trajx[][],trajy[][];
	int max,npart;

	Aire1Calculs(float hi0,float hx0,float v0,float dt0,int npart0, int max0) {
		double dx,dy,f,x,y;
		int k,l,m,n;

		hi = (double) hi0;
		hx = (double) hx0;
		v = (double) v0;
		dt = (double) dt0;
		npart = npart0;
		max = max0;
		trajx = new double[npart][max];
		trajy = new double[npart][max];

		for(m=0;m<npart;m++) {
			x=0;
			y=hx;
			for(n=0;n<max;n++) {
				k=0;
				for(l=0;l<10;l++)
					k=k+alea(2)-1;
				f=0.0d;
				if(y<hi)
					f=k/(5.0d);
        			else
					f=k/(20.0d);
				dx=v*dt;
				dy=v*f*dt;
				x=x+dx;
				y=y+dy;
				if(y<0.0d)
					y=-y;
				trajx[m][n]=x;
				trajy[m][n]=y;
			}
		}
	}

	public int alea(int i) {
		double a;
		int j,k;

		a = 1000.0d*Math.random();
		k = (int) a;
		j = k%(i+1);
		return j;
	}
}
